package com.example.pibd22_kalyshev_y_v_motorboat_hard;

import javafx.scene.canvas.GraphicsContext;
import javafx.scene.paint.Color;

public class DrawningOars implements IDrawningAdditionalElement{
    private Color _OarsColor;
    private NumberOars _numOars;
    public void SetNumberOars(int numberOars)
    {
        _numOars = NumberOars.FromInteger(numberOars);
    }
    public int deltaYdown = 0;
    public DrawningOars(Color oarsColor)
    {
        _OarsColor = oarsColor;
    }
    public void DrawOars(GraphicsContext gc, float startPosX, float startPosY) {
        if (_OarsColor == null) {
            return;
        }

        gc.setFill(_OarsColor);

        switch (_numOars) {
            case One:
                DrawOar1(gc, startPosX, startPosY);
                deltaYdown = 40;
                break;

            case Two:
                DrawOar1(gc, startPosX, startPosY);
                DrawOar2(gc, startPosX, startPosY);
                deltaYdown = 80;
                break;

            case Three:
                DrawOar1(gc, startPosX, startPosY);
                DrawOar2(gc, startPosX, startPosY);
                DrawOar3(gc, startPosX, startPosY);
                deltaYdown = 80;
                break;
        }
    }
    void DrawOar1(GraphicsContext gc, float startPosX, float startPosY) {
        gc.setFill(_OarsColor);
        gc.setStroke(Color.BLACK);
        gc.setLineWidth(2);
        gc.strokePolyline(new double[]{startPosX + 60, startPosX + 80, startPosX + 80, startPosX + 90, startPosX + 100, startPosX + 90, startPosX + 70, startPosX + 60},
                new double[]{startPosY + 60, startPosY + 20, startPosY + 10, startPosY, startPosY + 10, startPosY + 20, startPosY + 60, startPosY + 60}, 8);
        gc.fillPolygon(new double[]{startPosX + 60, startPosX + 80, startPosX + 80, startPosX + 90, startPosX + 100, startPosX + 90, startPosX + 70, startPosX + 60},
                new double[]{startPosY + 60, startPosY + 20, startPosY + 10, startPosY, startPosY + 10, startPosY + 20, startPosY + 60, startPosY + 60}, 8);
    }
    void DrawOar2(GraphicsContext gc, float startPosX, float startPosY) {
        gc.setFill(_OarsColor);
        gc.setStroke(Color.BLACK);
        gc.setLineWidth(2);
        gc.strokePolyline(new double[]{startPosX+50, startPosX+30, startPosX+20, startPosX+30, startPosX+40, startPosX+40, startPosX+60, startPosX+50},
                new double[]{startPosY+80, startPosY+120, startPosY+130, startPosY+140, startPosY+130, startPosY+120, startPosY+80, startPosY+80}, 8);
        gc.fillPolygon(new double[]{startPosX+50, startPosX+30, startPosX+20, startPosX+30, startPosX+40, startPosX+40, startPosX+60, startPosX+50},
                new double[]{startPosY+80, startPosY+120, startPosY+130, startPosY+140, startPosY+130, startPosY+120, startPosY+80, startPosY+80}, 8);
    }
    void DrawOar3(GraphicsContext gc, float startPosX, float startPosY) {
        gc.setFill(_OarsColor);
        gc.setStroke(Color.BLACK);
        gc.setLineWidth(2);
        gc.strokePolyline(new double[]{startPosX+90, startPosX+100, startPosX+100, startPosX+100, startPosX+110, startPosX+100, startPosX+90, startPosX+90},
                new double[]{startPosY+90, startPosY+90, startPosY+30, startPosY+40, startPosY+30, startPosY+20, startPosY+30, startPosY+90}, 8);
        gc.fillPolygon(new double[]{startPosX+90, startPosX+100, startPosX+100, startPosX+100, startPosX+110, startPosX+100, startPosX+90, startPosX+90},
                new double[]{startPosY+90, startPosY+90, startPosY+30, startPosY+40, startPosY+30, startPosY+20, startPosY+30, startPosY+90}, 8);
    }
}
