package com.example.pibd22_kalyshev_y_v_motorboat_hard;

import javafx.scene.paint.Color;
import java.util.Random;

public class EntityBoat
{
    private int _speed;
    private float _weight;
    private Color _bodyColor;
    public int GetSpeed()
    {
        return _speed;
    }

    public float GetWeight()
    {
        return _weight;
    }

    public Color GetBodyColor()
    {
        return _bodyColor;
    }

    public float GetStep()
    {
        return _speed * 100 / _weight;
    }

    public EntityBoat(int speed, float weight, Color bodyColor)
    {
        Random random = new Random();
        _speed = speed <= 0 ? random.nextInt(5) + 25 : speed;
        _weight = weight <= 0 ? random.nextInt(30) + 70 : weight;
        _bodyColor = bodyColor;
    }
}
